﻿using Silk.NET.OpenGL;
using StbImageSharp;

namespace Engine_silk.NET.Textures;

public enum ImageFormat
{
	Grey = ColorComponents.Grey,
	GreyAlpha = ColorComponents.GreyAlpha,
	RGB = ColorComponents.RedGreenBlue,
	RGBA = ColorComponents.RedGreenBlueAlpha,
}

internal static class ConverterExtensions
{
	internal static PixelFormat ImageFormatToPixelFormat(this ImageFormat imageFormat)
	{
		switch (imageFormat)
		{
			case ImageFormat.RGB:
				return PixelFormat.Rgb;
			case ImageFormat.RGBA:
				return PixelFormat.Rgba;
			default:
				throw new NotImplementedException($"Cannot map the given {nameof(ImageFormat)} '{imageFormat}' to a {nameof(PixelFormat)}");
		}
	}
}