#version 330 core

layout (location=0) in vec3 aPosition;
layout (location = 1) in vec3 normalVector;
layout (location = 2) in vec2 texCoords;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

out vec2 TexCoords;
out vec3 FragPos;
out vec3 Normal;

void main()
{
	vec4 pos = vec4(aPosition, 1.0);

	// TODO: calculate the inverse of the model matrix since "inverse()" is very costly to calculate for every vertex
	Normal = mat3(transpose(inverse(modelMatrix))) * normalVector;
	FragPos = vec3(modelMatrix * pos);
	TexCoords = texCoords;
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * pos;
}